<?php
if (!defined('SMF'))
	die('Hacking attempt...');

function Handler()
{
	// may get called from the main calendar OR the post display
	global $user_info, $smcFunc, $txt;

	checkSession('get');

	// sanitise numeric input!
	foreach ($_GET as $key=>$get)
		$_GET[$key] = (int)$_GET[$key];

	if (isset($_GET['eventid']) AND !($user_info['is_guest']))
	{
		// remove reminders for this event for this user
		$request = $smcFunc['db_query']('','
			DELETE FROM {db_prefix}hcb_reminders
			WHERE id_event = \'' . $_GET['eventid'] . '\'
				AND id_member=\'' . $user_info['id'] . '\''
			);
			
		if (isset($_GET['reminder']) AND isset($_GET['eventstart']) AND ($_GET['reminder'] > 0))
		{
			// reminder has to be possible within a day plus 30mins of the event
			if ((int)$_GET['eventstart'] - $_GET['reminder'] > (time() - 86400 - 1800))
			{
				// set new reminder
				$request = $smcFunc['db_query']('','
					INSERT INTO {db_prefix}hcb_reminders (id_member, id_event, remind_date)
					VALUES(\'' . $user_info['id'] . '\', \'' . $_GET['eventid'] . '\', \'' . $_GET['reminder'] . '\')'
					);
			}
			else
				fatal_error($txt['reminder_toolate'], false);
		}
	}

	if (isset($_GET['topic']))
		if (($_GET['topic']) != 0)
			redirectexit('topic='.$_GET['topic'].'.0');  // back to post topic
		else
			redirectexit(''); // back to home page	
	else // or... back to calendar
		redirectexit('action=calendar' . (isset($_GET['year']) ? ';year=' . $_GET['year'] : '') . (isset($_GET['month']) ? ';month=' . $_GET['month']:''). (isset($_GET['day']) ? ';day=' . $_GET['day']:''). (isset($_GET['viewweek']) ? ';viewweek' : '')); 
}



function SendReminders()
{	
	global  $mbname, $sourcedir, $scripturl, $txt, $smcFunc;
	// last update to handle reminders correctly if the event date is changed  AFTER  a reminder is set
	// detects if the datbase has an old version remider date set ((i.e. it was the actual date rather than the delay time period)
	
	loadEssentialThemeData();
	require_once($sourcedir . '/Subs-Post.php');

	// get list of events and reminders that have expired
	// has fudge to work with older version mod that stored the actual timestamp of the reminder rather than the period offset
	$result = $smcFunc['db_query']('', '
		SELECT r.id_remind, m.real_name, m.member_name, m.email_address, m.lngfile, c.title, UNIX_TIMESTAMP(c.start_date) as start_date, c.id_topic
		FROM {db_prefix}hcb_reminders AS r
			LEFT JOIN {db_prefix}members AS m ON r.id_member = m.id_member
			LEFT JOIN {db_prefix}calendar AS c ON r.id_event = c.id_event
		WHERE 
			FROM_UNIXTIME(IF(r.remind_date > ' . 4838400 . ', r.remind_date, UNIX_TIMESTAMP(c.start_date) - r.remind_date)) <= CURDATE()
	');

	// sort by language
	$recps = array();
	while ($row = $smcFunc['db_fetch_assoc']($result))
	{
		if (!isset($recps[$row['lngfile']]))
			$recps[$row['lngfile']] = array();
		$recps[$row['lngfile']][] = $row;
	}

	$smcFunc['db_free_result']($result);

	// Send out the reminder!
	$del_rem = array();
	foreach ($recps as $lang => $recps)
	{
		$loaded_lang = loadLanguage('EmailTemplates', $lang); 
		// we need to check if the mod has support for this user's language!)
		if (!isset($txt['emails']['event_reminder'] ))  // does this lang have our mod text?
			$loaded_lang = loadLanguage('EmailTemplates', 'english'); // nope, so default to english
		
		foreach ($recps as $recp)
		{
			$del_rem[] = $recp['id_remind']; // save the reminders we send (and any expired ones) so we can clean out the database
			if (!empty($recp['start_date']) AND $recp['start_date'] >= time());  // make sure the event still exists AND is still in the future!
			{
				// send reminder email....
				$emaildata = loadEmailTemplate(
						'event_reminder', 
						array(
							'REALNAME' => (isset($recp['real_name']) ? $recp['real_name'] : $recp['member_name']),
							'EVENTNAME' => $recp['title'],
							'EVENTSTART' => date("j M Y", $recp['start_date']),
							'TOPIC' => $scripturl . '?topic=' . $recp['id_topic'] . '.0',
						),
						$loaded_lang, 
						false
					);
				sendmail($recp['email_address'], $emaildata['subject'], $emaildata['body'], null, null, false, 2);
				@set_time_limit(300);
				if (function_exists('apache_reset_timeout'))
					@apache_reset_timeout();
			}
		}
		// Flush the mail queue, just in case.
		AddMailQueue(true);
	}

	if (!empty($del_rem))
		// remove expired reminders that we've sent!
		$request = $smcFunc['db_query']('','
			DELETE FROM {db_prefix}hcb_reminders
			WHERE FIND_IN_SET(id_remind,\'' . implode(',',$del_rem) . '\')'
			);

	return true;
}


function make_reminder_menu($event=array())
// construct HTML drop down menu for display and calendar templates
{
	global $context, $topic, $scripturl, $settings, $txt;

	$a_day = 60 * 60 * 24;
	if (empty($event) OR $event['start_timestamp'] - (time()) < ($a_day + 1800)) 
		return ''; // less than one day to go before start date so too late to set a reminder!

	$periods = array(
		$a_day			=> '1 ' . $txt['reminder_mod_day'], 
		$a_day * 2		=> '2 ' . $txt['reminder_mod_days'],
		$a_day * 4		=> '4 ' . $txt['reminder_mod_days'],
		$a_day * 7		=> '1 ' . $txt['reminder_mod_week'], 
		$a_day * 2 * 7	=> '2 ' . $txt['reminder_mod_weeks'], 
		$a_day * 4 * 7	=> '4 ' . $txt['reminder_mod_weeks'],
		$a_day * 6 * 7	=> '6 ' . $txt['reminder_mod_weeks'],
		$a_day * 8 * 7	=> '8 ' . $txt['reminder_mod_weeks'],
		);

	$url = '<li><a href="' . $scripturl . '?action=calreminder;eventid=' . $event['id'] . ';eventstart=' . $event['start_timestamp'] . ';topic=' .$topic . ';' . $context['session_var'] . '=' . $context['session_id'] . ';reminder=';

	$menu = '
<ul class="dropmenu" id="menu_rem' .$event['id'] . '" style="display:inline;">
	<li id="button_rem">
		<span class="firstlevel"><img src="' . $settings['default_images_url'] . '/icons/calreminder.png" alt="Set reminder" /></span>
		<ul>
			' . $url . '0' . '"><span>' . ($event['reminder']==0 ? '<img src="' . $settings['images_url'] . '/icons/field_valid.gif" alt="*" />' : '') . '&nbsp;' . $txt['reminder_noremind'] . '</span></a>
			</li>';

	foreach ($periods as $time=>$msg)
		if (($event['start_timestamp'] - $time) > time()) // only show if still time for this reminder interval
			$menu .= $url . $time . '"><span>' . ($event['reminder']==$time ? '<img src="' . $settings['images_url'] . '/icons/field_valid.gif" alt="*" />' : '') . 
					$msg . $txt['reminder_mod_before'] . date(' (j M)',$event['start_timestamp']-$time) . '</span></a></li>';
	return $menu . '
		</ul>
	</li>
</ul>';
}

?>